@simulation prog for Bull and Bear Markets@
@Described in Towards an Understanding of B and B Markets@

@dating bull and bear markets for the campbell-cochrane model@


@**************************************************************************@

@this program needs mainprc.prg and main.prg to be placed in the examples 
sub-directory of the main gauss directory. So they need to be resident in gauss36\examples
if one is using gauss 3.6@

@**************************************************************************@



@   This program is a an amalgam of Watson's 91 and 93 progs@
@rules used are those in Dow Theory@
@it eliminates all smoothing@

output file=c:\bbjaeprog\stkcyc.out reset;
output on;


ndfy = 1899;             @ First Year of data set @
ndfm = 1;                @ First Month of data set @
ndly = 1997;             @ Last Year of data set @
ndlm = 5;                @ Last Month of data set @

nsfy = 1899;              @ First Year of Sample (Used in Analysis) @
nsfm = 1;                 @ First Month of Sample @
nsly = 1997;              @ Last Year of Sample @
nslm = 5;                @ Last Month of Sample @

nsfy=ndfy;nsfm=ndfm;nsly=ndly;nslm=ndlm;


nd= 12*(ndly-1-ndfy) + (13-ndfm) + (ndlm);     @ Number of data points @
_divid=zeros(nd+1,1);_profstock=_divid;








cal=zeros(nd,1);

st=zeros(nd,1);


durs=zeros(nd,1);







ns1= 12*(nsfy-1-ndfy) + (13-ndfm) + (nsfm);    @ First Sample Point @
nd= 12*(nsly-1-nsfy) + (13-nsfm) + (nslm);  @ Number of data points - Sample @



durs=zeros(nd,1);bcp5=zeros(nd,1);bct5=zeros(nd,1);st=zeros(nd,1);


pds=zeros(1,1);tds=zeros(1,1);
pdsa=zeros(1,1);tdsa=zeros(1,1);

pdm=0;
pdma=0;
ppm=0;
ttm=0;
tdm=0;
tdma=0;
str=0;
spk=0;
nrep=10;

vtr=0;
vpk=0;
pdcm=0;
tdcm=0;
tdem=0;
tdema=0;

pdem=0;
pdema=0;

tc1=0;
tc2=0;

tsave1=zeros(nrep,10);


pdmmat=zeros(nrep,1);tdmmat=zeros(nrep,1);
pdmmata=zeros(nrep,1);tdmmata=zeros(nrep,1);

@set icensor@
@icensor =0 if no censoring =1 if is@
icensor=0;

iseed=92693370;
ibomb=1;

@ibomb is set at replication before bombed out@

@enables one to study why it happened as it generates the
right random no@

@gen occurs if only 1 peak or trough in series. This happens if trend is
very strong real to std dev of shock@



@ibomb=1;
i=1;
do while i<=ibomb;
e=rndns(nd,1,iseed);
i=i+1;
endo;@

/* insert parameters for Cambell-Cochrane*/
gamacc=2;           /*utility parameter*/
ficc=   .87;        /*annualized persistence coef*/
gcc=.0189;          /*annulized log of cons growth*/
rcc=exp(.0252);         /*annualized
                gross risk-free interesr rate i.e. 1.0094 is .94% pa*/
rocc=.2;        /* correl berween c and d shocks*/
csigcc=0.015;       /* annualized stdev of c shock*/
dsigcc=.112;        /* annualized stdev of d shock*/
_uselast=0;     /*set to 1 if already have p/d function in workspace*/

lndtbcc=0;LNPTCC=0;

#include main.prg;

iter=ibomb;
pmc=0|0;
do while iter<=nrep;
"iter= ";iter;



{x,pmc1,iseed}=cochr(iseed);
x=x+.0023*seqa(1,1,nd);
pmc=pmc~pmc1;



findates(x[1:nd],nd);


iter=iter+1;
endo;
pmc=pmc[.,2:rows(pmc')];pmc=pmc';

"statistics on average cycle";
"contractions/expansions";

"durations";

meanc(tsave1[.,1:2]);

"amplitudes";


meanc(tsave1[.,3:4]);


"cumulative movements";

meanc(tsave1[.,5:6]);


"excess movements ";

meanc(tsave1[.,7:8]);



"fraction of bear <20;bull>20";

meanc(tsave1[.,9:10]);



"mean and stdev of difference of claim on divedends steram";
meanc(pmc);
i=1;
output file=c:\bbjaeprog\pvals.dat reset;
output on;
screen off;
do while i<=nrep;

tsave1[i,.];
i=i+1;
endo;

end;


proc(2) = enfve_2(bcp,bct,x);

local anmat,nv,j,cind,nind,s,an;
anmat=zeros(nd,1);

@ Skip this procedure if either bcpn or bctn contain missing values @
if (scalmiss(bcp) .== 1) .or (scalmiss(bct) .== 1);
 retp(bcp,bct);
endif;

bcp=bcp~ones(rows(bcp),1);
bct=bct~zeros(rows(bct),1);
anmat=sortc((bcp|bct),1);

nv=0;
j=1;do while j <= (rows(anmat)-1);
   bcp=bcp~ones(rows(bcp),1);
   bct=bct~zeros(rows(bct),1);
   anmat=sortc((bcp|bct),1);
   if j+1 .> rows(anmat); break; endif;
  cind=anmat[j,1];nind=anmat[j+1,1];
   if nind-cind .< 4;nv=1;
   if abs(x[nind]-x[cind]) .> .2;
nv=0;
goto skip;
endif;

        if anmat[j+1,2]==1;
an=anmat[j+1,1];


        else;

 endif;
      s=zeros(rows(anmat),1); s[j+1,1]=1; anmat=delif(anmat,s);
      bcp=selif(anmat,anmat[.,2] .> 0);bct=selif(anmat,anmat[.,2] .< 1);
      if (scalmiss(bcp) .== 1) .or (scalmiss(bct) .== 1);
       retp(bcp,bct);
      endif;

      {bcp,bct}=alter2(bcp,bct,x);j=j-1;
   endif;
skip:
j=j+1;endo;

if nv==0; endif;

bcp=bcp[.,1];
bct=bct[.,1];

retp(bcp,bct);
endp;







proc(2) = enf1p(bcp,bct,x);

/*
   Enforce 16 month P-P and T-T cycles.
   If Violated, choose highest peak and lowest trough
*/
local i, s, d1, d2;
@ Check Peak to Peak @
i=2; do while i <= rows(bcp);
  if (bcp[i,1] - bcp[i-1,1]) .< 16;
   s=zeros(rows(bcp),1);
   d1=bcp[i-1,1]; d2=bcp[i,1];
   if x[d1,1] .> x[d2,1]; s[i,1]=1;else;s[i-1,1]=1;endif;
   bcp=delif(bcp,s);
  endif;
i=i+1; endo;
{bcp,bct}=alter2(bcp,bct,x);  @ Impose Alternating P,T @

@ Check Trough to Trough @
i=2; do while i <= rows(bct);
  if (bct[i,1] - bct[i-1,1]) .< 16;
   s=zeros(rows(bct),1);
   d1=bct[i-1,1]; d2=bct[i,1];
   if x[d1,1] .< x[d2,1]; s[i,1]=1;else;s[i-1,1]=1;endif;
   bct=delif(bct,s);
  endif;
i=i+1; endo;
{bcp,bct}=alter2(bcp,bct,x);  @ Impose Alternating P,T @
retp(bcp,bct);
endp;

proc(0) = prdatesp(cal,b);

/* Print Cycle Dates */

local i;

i=1; do while i <= rows(b);
i=i+1; endo;

retp;
endp;
proc(2) = enfvep(bcp,bct,x);
/*
   Eliminate Phases less than 4 months.
   (Save lowest troughs and highest peaks)
*/
local i,s;
top1:
i=1; do while i <= minc(rows(bcp)|rows(bct));
  if abs(bcp[i,1] - bct[i,1]) .< 4;
   if bcp[i,1] .> bct[i,1];  @ Eliminate peak @
    s=zeros(rows(bcp),1);
    s[i,1]=1;
    bcp=delif(bcp,s);
   else;                     @ Eliminate Trough @
    s=zeros(rows(bct),1);
    s[i,1]=1;
    bct=delif(bct,s);
   endif;
   {bcp,bct}=alter2(bcp,bct,x);
   goto top1;
  endif;
i=i+1; endo;

retp(bcp,bct);
endp;


proc(2) = alter2(bcpn,bctn,x);

/* Enforces alternation between Peaks and Troughs */

local anmat,j,cval,nval,s,d1,d2,nv;

@ Skip this procedure if either bcpn or bctn contain missing values @
if (scalmiss(bcpn) .== 1) .or (scalmiss(bctn) .== 1);
 retp(bcpn,bctn);
endif;

bcpn=bcpn~ones(rows(bcpn),1);
bctn=bctn~zeros(rows(bctn),1);
anmat=sortc((bcpn|bctn),1);


nv=0;
j=1; do while j <= (rows(anmat)-1);
  cval=anmat[j,2];
  nval=anmat[j+1,2];
    if nval==cval;
       if cval==1;

          @ -- eliminate lesser of two peaks
            -- in case of eliminate last peak @
          s=zeros(rows(anmat),1);
          d1=anmat[j,1];
          d2=anmat[j+1,1];


          if x[d1,1] .>= x[d2,1]; s[j+1,1]=1;
          else; s[j,1]=1; endif;
          anmat=delif(anmat,s); nv=1;
          j=j-1;
        else;

          @ -- eliminate greater of two troughs
            -- in case of eliminate first trough @
          s=zeros(rows(anmat),1);
          d1=anmat[j,1];
          d2=anmat[j+1,1];
          if x[d1,1] .>= x[d2,1]; s[j,1]=1;
          else; s[j+1,1]=1; endif;
          anmat=delif(anmat,s); nv=1;
          j=j-1;
       endif;
    endif;
j=j+1;
endo;

if nv==0;  endif;

bcpn=selif(anmat,anmat[.,2] .> 0);
bctn=selif(anmat,anmat[.,2] .< 1);

bcpn=bcpn[.,1];
bctn=bctn[.,1];

 retp(bcpn,bctn);
endp;



proc(2) = enfvbp(bcp,bct,x);
/*
   Eliminate Turns with 4 months of beginning and end of series
*/
local s;

@ Check Peaks @
s=zeros(rows(bcp),1);
if bcp[1,1] .<= 4; s[1,1]=1;
endif;
if bcp[rows(bcp),1] .> rows(x)-4; s[rows(bcp),1]=1;
endif;
bcp=delif(bcp,s);

@ Check Troughs @
s=zeros(rows(bct),1);
if bct[1,1] .<= 4; s[1,1]=1;
endif;
if bct[rows(bct),1] .> rows(x)-4; s[rows(bct),1]=1;
endif;
bct=delif(bct,s);

@ Make Sure Dates Alternate @
{bcp,bct}=alter2(bcp,bct,x);

retp(bcp,bct);
endp;

proc(2) = enfvcp(bcp,bct,x);
/*
 Elimination of Peaks (and Troughs) at both ends which are lower (or higher)
 than values closer to end
*/
local m, s, d1;
top:
@ Check First Date @
m=minc(bcp|bct);
if m .== minc(bcp); @ First TP is a peak @
s=zeros(rows(bcp),1);
d1=bcp[1,1];
if x[1,1] .> x[d1,1]; s[1,1]=1;
 bcp=delif(bcp,s); goto top;
endif;

else; @ First TP is a trough @
s=zeros(rows(bct),1);
d1=bct[1,1];
if x[1,1] .< x[d1,1]; s[1,1]=1;
 bct=delif(bct,s); goto top;
endif;

endif;

@ Check last Date @
m=maxc(bcp|bct);
if m .== maxc(bcp); @ Last TP is a peak @
s=zeros(rows(bcp),1);
d1=bcp[rows(bcp),1];
if x[rows(x),1] .> x[d1,1]; s[rows(bcp),1]=1;
 bcp=delif(bcp,s); goto top;
endif;

else; @ last TP is a trough @
s=zeros(rows(bct),1);
d1=bct[rows(bct),1];
if x[rows(x),1] .< x[d1,1]; s[rows(bct),1]=1;
 bct=delif(bct,s); goto top;
endif;
endif;

@ Make Sure Date Alternate @
{bcp,bct}=alter2(bcp,bct,x);

retp(bcp,bct);
endp;











 proc(2) = dates1(x,cal);
/*
   Dates1.gss
   mww, 6/30/91
*/
local peak1, trough1, nd, i;
nd=rows(x);
peak1=zeros(nd,1);
trough1=zeros(nd,1);

@   Step 1;
   Determine dates that are higher than any values 8 months
   Determine dates that are lower  than any values 8 months
   These are initial peak an trough
@

i=9; do while i <= nd-8;
  if x[i,1] .== maxc(x[i-8:i+8,1]); peak1[i,1]=1;
                             endif;
  if x[i,1] .== minc(x[i-8:i+8,1]); trough1[i,1]=1;
                            endif;

i=i+1; endo;
print;

retp(peak1,trough1);
endp;

proc(0) = dates(bcp,bct);

local bp,bt,analmat,j;

@ This procedure takes peak and trough strings and puts turning points @
@ in chronological order for convenient viewing in output file @



bp=bcp~ones(rows(bcp),1);
bt=bct~zeros(rows(bct),1);
analmat=sortc((bp|bt),1);

j=1; do while j <= rows(analmat);
   if analmat[j,2] .== 1;
                               else;

   endif;
j=j+1; endo;

retp;
endp;






proc(0)=findates(x,nd);

local d,peak1,trough1,t,bcp2,bct2;
local bct1,bcp1,bct3,bcp3,bct4,bcp4,bct5,bcp5;
local r, k;
local ntr, npk, v,ic1,ic2;
local td,pd,pdc,tdc,pde,tde,pda,tda,pdea,tdea;
local dp,dt;


@ Set Up Calendar @
d= seqa(0,1,nd+12);
d=(int(d./12)+nsfy)~((d%12)+ones(nd+12,1));
cal=d[nsfm:nd+nsfm-1,.];




@initial dates @

{peak1,trough1}=dates1(x,cal);

t=seqa(1,1,rows(x));
bcp2=selif(t,peak1);
bct2=selif(t,trough1);

@ lot of this is redundant. bcp3 etc could be skipped but are relics of the
old Bry Boschan stages@


prdatesp(cal,bcp2);

prdatesp(cal,bct2);   @ bct2 and bcp2 contain turning points after step 2 @

bcp3=bcp2;bct3=bct2;
             @ B. Enforce 15 month minimum P-P and T-T cycles @
{bcp3,bct3}=enf1p(bcp3,bct3,x);



@step below is not used@
             @ A. Refine Previous Dates to 5 using of x4 @
bcp4=bcp3;bct4=bct3;

@ Step V: Refine these using the actual series @
bcp5=bcp4;bct5=bct4;
             @ B. Eliminate Turns with 6 months of beginning and end
                  of series @
{bcp5,bct5}=enfvbp(bcp5,bct5,x);
             @ C. Elimination of Peaks (and Troughs) at both ends which
               are lower (or higher) than values closer to end @
{bcp5,bct5}=enfvcp(bcp5,bct5,x);
             @ D. Elimination of P-P and T-T cycles less than 16 months @
{bcp5,bct5}=enf1p(bcp5,bct5,x);
             @ E. Eliminate Phases whose duration is less than 4  months @

{bcp5,bct5}=enfve_2(bcp5,bct5,x);


prdatesp(cal,bcp5);

prdatesp(cal,bct5);
dates(bcp5,bct5);

ntr=rows(bct5);npk=rows(bcp5);
pdc=zeros(nd,1);tdc=zeros(nd,1);

@states vector computred@



@cumulative periods spent in phases for duration dependence tests computed@



dp=bcp5[2:rows(bcp5),1]-bcp5[1:rows(bcp5)-1,1];
dt=bct5[2:rows(bct5),1]-bct5[1:rows(bct5)-1,1];

@print statistics@



if bcp5[1,1] .< bct5[1,1]; @ Peaks are first @
 r=minc(rows(bcp5)|rows(bct5));
 pd=bct5[1:r,1]-bcp5[1:r,1];

pda=x[bct5[1:r,1]]-x[bcp5[1:r,1]];

k=1;
do while k<=r;

pdc[k]=sumc(x[bcp5[k,1]:bct5[k,1],1]-x[bcp5[k,1],1]);




k=k+1;
endo;


else;                      @ troughs are First @
 r=minc(rows(bcp5)|rows(bct5)-1);

 pd=bct5[2:r+1,1]-bcp5[1:r,1];

pda=x[bct5[2:r+1,1]]-x[bcp5[1:r,1]];


k=1;
do while k<=r;
 pdc[k]=sumc(x[bcp5[k,1]:bct5[k+1,1],1]-x[bcp5[k,1],1]);

k=k+1;
endo;





endif;

@ Calculate Trough to Peak Durations and amplitudes@
if bct5[1,1] .< bcp5[1,1]; @ Troughs are first @
 r=minc(rows(bct5)|rows(bcp5));
 td=bcp5[1:r,1]-bct5[1:r,1];
tda=x[bcp5[1:r,1]]-x[bct5[1:r,1]];


k=1;
do while k<=r;
 tdc[k]=sumc(x[bct5[k,1]:bcp5[k,1],1]-x[bct5[k,1],1]);

k=k+1;
endo;




else;                      @ peaks are First @
 r=minc(rows(bct5)|rows(bcp5)-1);
 td=bcp5[2:r+1,1]-bct5[1:r,1];

tda=x[bcp5[2:r+1,1]]-x[bct5[1:r,1]];


k=1;
do while k<=r;


 tdc[k]=sumc(x[bct5[k,1]:bcp5[k+1,1],1]-x[bct5[k,1],1]);


k=k+1;
endo;



endif;

pdc=pdc[1:rows(pd)];


tdc=tdc[1:rows(td)];

@compute excesses@


v=-.22;


ic1=counts(pda,v)/rows(pda);
v=.18;




ic2=1-(counts(tda,v)/rows(tda));
pde=(pdc-.5*pda-((pd.*pda)/2))./pd;
pdea=abs(pdc-((pd.*pda)/2))./pd;



tde=(tdc-.5*tda-((td.*tda)/2))./td;



@cumulate. When nrep=1 then gives raw data, otherwsise sums over monte
carlo amounts@

tsave1[iter,1]=meanc(pd);
tsave1[iter,2]=meanc(td);
tsave1[iter,3]=meanc(pda);
tsave1[iter,4]=meanc(tda);
tsave1[iter,5]=meanc(pdc);
tsave1[iter,6]=meanc(tdc);

tsave1[iter,7]=meanc(pde);
tsave1[iter,8]=meanc(tde);

tsave1[iter,9]=ic1;

tsave1[iter,10]=ic2;





pdm=pdm+meanc(pd);
pdma=pdma+meanc(pda);

tdm=tdm+meanc(td);
tdma=tdma+meanc(tda);

tc1=tc1+ic1;
tc2=tc2+ic2;

pdcm=pdcm+meanc(pdc);
tdcm=tdcm+meanc(tdc);

retp;
endp;











proc(3)=cochr(iseed);

call simvars(0,0,0);
@retp(lnpd1tb[2:rows(lnpd1tb)],meanc(lnptcc)|stdc(lnptcc),iseed);@
retp(_profstock[2:rows(_profstock)],meanc(lnptcc)|stdc(lnptcc),iseed);
endp;

